#include <iostream>

template<int k>
class Matrix{
private:
    Matrix<k-1> a11,a12,a21,a22;
    int n;
public:
    Matrix(const Matrix<k-1>& a, const Matrix<k-1>& b, const Matrix<k-1>& c, const Matrix<k-1>& d): a11(a),a12(b),a21(c),a22(d),n(1<<k){}
    Matrix():n(1<<k){}

    double& operator() (int i, int j){
        if (i< n/2){
            if (j<n/2)
                return a11(i,j);
            else
                return a12(i,j-n/2);
        } else {
            if (j<n/2)
                return a21(i-n/2,j);
            else
                return a22(i-n/2,j-n/2);
        }
    }
    int order() const {return n;}
    
    void affiche(){
        for (int i=0; i<n; i++){
            for (int j=0; j<n; j++)
                std::cout<<operator()(i,j)<<" ";
            std::cout<<std::endl;
        }
    }
    template <int l>
    friend Matrix<l> operator+(const Matrix<l>& a, const Matrix<l>& b);
    template <int l>
    friend Matrix<l> operator*(const Matrix<l>& a, const Matrix<l>& b);
};

template <int  k>
Matrix<k> operator+(const Matrix<k>& a, const Matrix<k>& b){
    return Matrix<k> (a.a11+b.a11,a.a12+b.a12,a.a21+b.a21,a.a22+b.a22);
}
template <int  k>
Matrix<k> operator*(const Matrix<k>& a, const Matrix<k>& b){
    return Matrix<k> (a.a11*b.a11 + a.a12*b.a21,
                      a.a11*b.a12 + a.a12*b.a22,
                      a.a21*b.a11 + a.a22*b.a21,
                      a.a21*b.a12 + a.a22*b.a22);
}

template<>
class Matrix<0> {
//  private:
    double val;
public:
    template<int l>
    friend Matrix<l> operator+(const Matrix<l>& a, const Matrix<l>& b);
    template<int l>
    friend Matrix<l> operator*(const Matrix<l>& a, const Matrix<l>& b);
    Matrix<0>(double x=0):val(x){}
    double& operator()  (int i, int j){return val;}
    int getOrder() const {return 1;}
};
    
template <>
Matrix<0> operator+(const Matrix<0>& a, const Matrix<0>& b){
    return Matrix<0> (a.val+b.val);
}
template <>
Matrix<0> operator*(const Matrix<0>& a, const Matrix<0>& b){
    return Matrix<0> (a.val*b.val);
}

int main(){
    Matrix<3> a;
    a(1,2) = 2;
    a(4,1) = 3;
    a(6,4) = 1;
    Matrix<3> c = a+a;
    c.affiche();
    Matrix<3> d = a*c;
    std::cout<<std::endl;
    d.affiche();
    
}
