#include <iostream>

template<int k, class Coeff>
class Matrix{
private:
    Matrix<k-1, Coeff> a11,a12,a21,a22;
    int n;
public:
    Matrix(const Matrix<k-1, Coeff>& a, const Matrix<k-1, Coeff>& b, const Matrix<k-1, Coeff>& c, const Matrix<k-1, Coeff>& d): a11(a),a12(b),a21(c),a22(d),n(1<<k){}
    Matrix():n(1<<k){}

    Coeff& operator() (int i, int j){
        if (i< n/2){
            if (j<n/2)
                return a11(i,j);
            else
                return a12(i,j-n/2);
        } else {
            if (j<n/2)
                return a21(i-n/2,j);
            else
                return a22(i-n/2,j-n/2);
        }
    }
    int order() const {return n;}
    
    void affiche(){
        for (int i=0; i<n; i++){
            for (int j=0; j<n; j++)
                std::cout<<operator()(i,j)<<" ";
            std::cout<<std::endl;
        }
    }
    template <int l, class Co>
    friend Matrix<l, Co> operator+(const Matrix<l, Co>& a, const Matrix<l, Co>& b);
    template <int l, class Co>
    friend Matrix<l, Co> operator*(const Matrix<l, Co>& a, const Matrix<l, Co>& b);
};

template <int  k, class Coeff>
Matrix<k, Coeff> operator+(const Matrix<k, Coeff>& a, const Matrix<k, Coeff>& b){
    return Matrix<k, Coeff> (a.a11+b.a11,a.a12+b.a12,a.a21+b.a21,a.a22+b.a22);
}
template <int  k, class Coeff>
Matrix<k, Coeff> operator*(const Matrix<k, Coeff>& a, const Matrix<k, Coeff>& b){
    return Matrix<k, Coeff> (a.a11*b.a11 + a.a12*b.a21,
                      a.a11*b.a12 + a.a12*b.a22,
                      a.a21*b.a11 + a.a22*b.a21,
                      a.a21*b.a12 + a.a22*b.a22);
}

template<class Coeff>
class Matrix<0, Coeff> {
//  private:
    Coeff val;
public:
    template<class Co>
    friend Matrix<0, Co> operator+(const Matrix<0, Co>& a, const Matrix<0, Co>& b);
    template<class Co>
    friend Matrix<0, Co> operator*(const Matrix<0, Co>& a, const Matrix<0, Co>& b);
    Matrix<0, Coeff>(double x=0):val(x){}
    Coeff& operator()  (int i, int j){return val;}
    int getOrder() const {return 1;}
};
    
template <class Coeff>
Matrix<0, Coeff> operator+(const Matrix<0, Coeff>& a, const Matrix<0, Coeff>& b){
    return Matrix<0, Coeff> (a.val+b.val);
}
template <class Coeff>
Matrix<0, Coeff> operator*(const Matrix<0, Coeff>& a, const Matrix<0, Coeff>& b){
    return Matrix<0, Coeff> (a.val*b.val);
}

int main(){
    Matrix<3, int> a;
    a(1,2) = 2;
    a(4,1) = 3;
    a(6,4) = 1;
    Matrix<3, int> c = a+a;
    c.affiche();
    Matrix<3, int> d = a*c;
    std::cout<<std::endl;
    d.affiche();
    
}
